<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card max-width="90%">
            <v-card-title>
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.title}}</td>
                            <td>{{ item.size}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>


                            <td>
                                <v-btn small color="success" @click="showPhoto(item)">
                                    {{'مشاهده عکس'}}
                                </v-btn>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout>
                            <v-flex>
                                <v-text-field @change="setTitle" v-model="selectedItem.title"
                                              label="عنوان"></v-text-field>
                            </v-flex>
                            <v-flex>
                                <v-text-field @change="setSize" v-model="selectedItem.size"
                                              label="اندازه"></v-text-field>
                            </v-flex>
                            <v-flex xs3 md3>
                                <v-btn
                                        type="file"
                                        color="blue"
                                        class="white--text"

                                        @click="()=>this.$refs.image.click ()"
                                >
                                    انتخاب عکس
                                    <input
                                            type="file"
                                            style="display: none"
                                            ref="image"
                                            accept="image/*"
                                            @change="onFilePicked"

                                    />
                                </v-btn>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این آیتم را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
                v-model="photoDialog"
                max-width="90%"
        >
            <v-card
                    white
            >
                <v-card-text>
                    <v-layout align-center justify-center>
                        <img :src="selectedItem.media_url">
                    </v-layout>
                </v-card-text>


                <v-card-actions>
                    <v-btn color="blue darken-1" flat @click="hidePhotoDialog">بستن</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "advertise",
        methods: {
            ...mapMutations({
                setTitle: 'advertise/setTitle',
                setSize: 'advertise/setSize',
                setImage: 'advertise/setImage',
                setSelectedItem: 'advertise/setSelectedItem',
                showAddDialog: 'advertise/showAddDialog',
                hideAddDialog: 'advertise/hideAddDialog',
                showPhotoDialog: 'driver/showPhotoDialog',
                hidePhotoDialog: 'driver/hidePhotoDialog',
                showDeleteDialog: 'advertise/showDeleteDialog',
                hideDeleteDialog: 'advertise/hideDeleteDialog'
            }),
            ...mapActions({
                readData: 'advertise/readData',
                addOrEdit: 'advertise/addOrEdit',
                deleteOne: 'advertise/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    title: null,
                    size: null,
                    media_url: null,
                    image: null,
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    title: item.title,
                    size: item.size,
                    media_url: item.media_url,
                    image: item.image,
                });
                this.showAddDialog();
            },
            add_Edit() {
                this.addOrEdit();
            },
            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },

            showPhoto(item) {
                this.setSelectedItem(item);
                this.showPhotoDialog();
            },
            onFilePicked(e) {
                const files = e.target.files

                if (files[0] !== undefined) {
                    this.$root.imageName = files[0].name
                    if (this.$root.imageName.lastIndexOf('.') <= 0) {
                        return
                    }
                    const fr = new FileReader();
                    fr.readAsDataURL(files[0]);
                    fr.addEventListener('load', () => {
                        this.$root.imageUrl = fr.result;
                        this.$root.imageFile = files[0];// this is an image file that can be sent to server...
                        this.setImage(files[0]);
                    })
                } else {
                    this.$root.imageName = '';
                    this.$root.imageFile = '';
                    this.$root.imageUrl = '';
                }
            },
        },
        computed: {
            ...mapState({
                allData: state => state.advertise.allData,
                AddDialog: state => state.advertise.AddDialog,
                DeleteDialog: state => state.advertise.DeleteDialog,
                selectedItem: state => state.advertise.selectedItem,
                pending: state => state.advertise.pending,
                allDataLoading: state => state.advertise.allDataLoading,
                photoDialog: state => state.driver.photoDialog,
            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                headers: [
                    {text: 'عنوان', align: 'right', value: 'title'},
                    {text: 'اندازه', align: 'right', value: 'size'},
                ],
            }
        },

    }
</script>
<style scoped>
</style>